import 'dart:convert';

import 'package:diplomaticquarterapp/config/shared_pref_kay.dart';
import 'package:diplomaticquarterapp/models/Appointments/AppoimentAllHistoryResultList.dart';
import 'package:diplomaticquarterapp/models/Authentication/authenticated_user.dart';
import 'package:diplomaticquarterapp/services/authentication/auth_provider.dart';
import 'package:diplomaticquarterapp/uitl/app_shared_preferences.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';

class MyInAppBrowser extends InAppBrowser {
  static String SERVICE_URL =
      'https://hmgwebservices.com/PayFortWeb/pages/SendPayFortRequest.aspx'; // Payfort Payment Gateway URL UAT

//  static String SERVICE_URL =
//      'https://hmgwebservices.com/PayFortWebLive/pages/SendPayFortRequest.aspx'; //Payfort Payment Gateway URL LIVE

  static String PREAUTH_SERVICE_URL =
      'https://hmgwebservices.com/PayFortWeb/pages/SendPayFortRequest.aspx'; // Payfort PreAuth Payment Gateway URL UAT

//  static String PREAUTH_SERVICE_URL =
//      'https://hmgwebservices.com/PayFortWebLive/pages/SendPayFortRequest.aspx'; //Payfort PreAuth Payment Gateway URL Live Store

  static List<String> successURLS = [
    'success',
    'PayFortResponse',
    'PayFortSucess'
  ];

  static List<String> errorURLS = ['PayfortCancel'];

  final Function onExitCallback;
  final Function onLoadStartCallback;

  AppSharedPreferences sharedPref = AppSharedPreferences();
  AuthProvider authProvider = new AuthProvider();
  InAppBrowser browser = new InAppBrowser();

  AuthenticatedUser authUser;
  AppoitmentAllHistoryResultList appo;

  static bool isPaymentDone = false;

  MyInAppBrowser({this.onExitCallback, this.appo, this.onLoadStartCallback});

  Future onBrowserCreated() async {
    print("\n\nBrowser Created!\n\n");
  }

  @override
  Future onLoadStart(String url) async {
    onLoadStartCallback(url);
  }

  @override
  Future onLoadStop(String url) async {
    print("\n\nStopped $url\n\n");
  }

  @override
  void onLoadError(String url, int code, String message) {
    print("Can't load $url.. Error: $message");
  }

  @override
  void onProgressChanged(int progress) {
    print("Progress: $progress");
  }

  @override
  void onExit() {
    print("\n\nBrowser closed!\n\n");
    onExitCallback(appo, isPaymentDone);
  }

  @override
  Future<ShouldOverrideUrlLoadingAction> shouldOverrideUrlLoading(
      ShouldOverrideUrlLoadingRequest shouldOverrideUrlLoadingRequest) async {
    print("\n\n override ${shouldOverrideUrlLoadingRequest.url}\n\n");
    return ShouldOverrideUrlLoadingAction.ALLOW;
  }

  getLanguageID() async {
    return await sharedPref.getString(APP_LANGUAGE);
  }

  Future<String> getDeviceToken() async {
    String deviceToken = await sharedPref.getString(PUSH_TOKEN);
    return deviceToken;
  }

  getPatientData() async {
    if (await this.sharedPref.getObject(USER_PROFILE) != null) {
      var data = AuthenticatedUser.fromJson(
          await this.sharedPref.getObject(USER_PROFILE));
      authUser = data;
    }
  }

  openPaymentBrowser(
    double amount,
    String orderDesc,
    String transactionID,
    String projId,
    String emailId,
    String paymentMethod,
    AuthenticatedUser authenticatedUser,
    InAppBrowser browser,
  ) {
    this.browser = browser;
    this.browser.openUrl(
        url: generateURL(amount, orderDesc, transactionID, projId, emailId,
            paymentMethod, authenticatedUser));
  }

  openBrowser(String url) {
    this.browser = browser;
    this.browser.openUrl(url: url);
  }

  String generateURL(
      double amount,
      String orderDesc,
      String transactionID,
      String projId,
      String emailId,
      String paymentMethod,
      AuthenticatedUser authUser,
      [var patientData,
      var servID,
      var LiveServID]) {
    getPatientData();
    String currentLanguageID = getLanguageID() == 'ar' ? 'AR' : 'EN';
    String form = getForm();
    String deviceToken;

    getDeviceToken().then((value) {
      print(value);
      deviceToken = value;
    });

    if (authUser != null) {
      form = form.replaceFirst("EMAIL_VALUE", authUser.emailAddress);
    } else {
      form = form.replaceFirst("EMAIL_VALUE", emailId);
    }

    form = form.replaceFirst('AMOUNT_VALUE', amount.toString());
    form = form.replaceFirst('ORDER_DESCRIPTION_VALUE', orderDesc);
    form = form.replaceFirst('ORDER_ID_VALUE', transactionID);
    form = form.replaceFirst('REQUEST_ID_VALUE', transactionID);
    form = form.replaceFirst('PROJECT_ID_VALUE', projId);
    form = form.replaceFirst('PAYMENT_OPTION_VALUE', paymentMethod);
    form = form.replaceFirst('LANG_VALUE', currentLanguageID);
    form = form.replaceFirst('PATIENT_OUT_SA',
        authUser.outSA == 0 ? false.toString() : true.toString());
    form = form.replaceFirst(
        'PATIENT_TYPE_ID',
        patientData == null
            ? authUser.patientType.toString()
            : patientData.PatientType);

//    form = form.replaceFirst('DEVICE_TOKEN', this.cs.sharedService.getSharedData(AuthenticationService.DEVICE_TOKEN, false) + "," + this.cs.sharedService.getSharedData(AuthenticationService.APNS_TOKEN, false));
//    form = form.replaceFirst('LATITUDE_VALUE', this.cs.sharedService.getSharedData('userLat', false));
//    form = form.replaceFirst('LONGITUDE_VALUE', this.cs.sharedService.getSharedData('userLong', false));

    form = form.replaceFirst('LATITUDE_VALUE', "24.708488");
    form = form.replaceFirst('LONGITUDE_VALUE', "46.665925");
    form = form.replaceFirst('DEVICE_TOKEN',
        "e8wKxa4EGK8:APA91bGtygxh5E22pSARVKlngyi0iQbyRUvvUWiCIsaAcbE0hiffhUR094WVx22O5bsvwc706LspzIuJthUyK_748jzuaedD-ZwDm9BX_yyYV2K2YnuFBlHQ9pOKy65RfoprtvqyTN1O");

    if (servID == "4")
      form = form.replaceFirst(
          'SERVICE_URL_VALUE', MyInAppBrowser.PREAUTH_SERVICE_URL);
    else
      form = form.replaceFirst('SERVICE_URL_VALUE', MyInAppBrowser.SERVICE_URL);

    if (servID != null) {
      form = form.replaceFirst('SERV_ID', servID);
      form = form.replaceFirst('LIVE_SERVICE_ID', LiveServID);
    } else {
      form = form.replaceFirst('SERV_ID', "2");
      form = form.replaceFirst('LIVE_SERVICE_ID', "2");
    }

    if (patientData == null) {
      form = form.replaceFirst('CUSTNAME_VALUE', authUser.firstName);
      form = form.replaceFirst('CUSTID_VALUE', authUser.patientID.toString());
    } else {
      form = form.replaceFirst('CUSTNAME_VALUE', patientData.FirstName);
      form = form.replaceFirst('CUSTID_VALUE', patientData.PatientID);
    }

    var bytes = utf8.encode(form);
    var base64Str = base64.encode(bytes);
    print(form);
    print('data:text/html;base64,' + base64Str);
    return 'data:text/html;base64,' + base64Str;
  }

  String getForm() {
    return '<html> ' +
        '<head></head>' +
        '<body>' +
        '<form id="paymentForm" action="SERVICE_URL_VALUE" method="post">' +
        '<input type="hidden" name="Amount" value="AMOUNT_VALUE">' +
        '<input type="hidden" name="ProjID" value="PROJECT_ID_VALUE">' +
        '<input type="hidden" name="Order_Desc" value="ORDER_DESCRIPTION_VALUE">' +
        '<input type="hidden" name="OrderID" value="ORDER_ID_VALUE">' +
        // '<input type="hidden" name="reqID" value="REQUEST_ID_VALUE">' +
        '<input type="hidden" name="PaymentOption" value="PAYMENT_OPTION_VALUE">' +
        '<input type="hidden" name="Email" value="EMAIL_VALUE">' +
        '<input type="hidden" name="ServID" value="SERV_ID"  >' +
        '<input type="hidden" name="ChannelID" value="2"  >' +
        '<input type="hidden" name="Lang" value="LANG_VALUE"  >' +
        '<input type="hidden" name="ReturnURL" value=""  >' +
        '<input type="hidden" name="CustName" value="CUSTNAME_VALUE" >' +
        '<input type="hidden" name="PatientOutSA" value="PATIENT_OUT_SA" >' +
        '<input type="hidden" name="PatientTypeID" value="PATIENT_TYPE_ID" >' +
        '<input type="hidden" name="DeviceToken" value="DEVICE_TOKEN" >' +
        '<input type="hidden" name="Longitude" value="LONGITUDE_VALUE" >' +
        '<input type="hidden" name="Latitude" value="LATITUDE_VALUE" >' +
        '<input type="hidden" name="Live_ServiceID" value="LIVE_SERVICE_ID" >' +
        '<input type="hidden" name="CustID" value="CUSTID_VALUE"  >' +
        '<input type="hidden" name="ResponseContinueURL" value="http://hmg.com/Documents/success.html" >' +
        '<input type="hidden" name="BackClickUrl" value="http://hmg.com/Documents/success.html" >' +
        '</form>' +
        '<script type="text/javascript"> document.getElementById("paymentForm").submit(); </script>' +
        '</body>' +
        '</html>';
  }
}
